package cn.iocoder.yudao.module.pms.service.iotsapsynclog;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;
import cn.iocoder.yudao.module.pms.controller.admin.iotsapsynclog.vo.IotSapSyncLogPageReqVO;
import cn.iocoder.yudao.module.pms.controller.admin.iotsapsynclog.vo.IotSapSyncLogSaveReqVO;
import cn.iocoder.yudao.module.pms.dal.dataobject.iotsapsynclog.IotSapSyncLogDO;
import cn.iocoder.yudao.module.pms.dal.mysql.iotsapsynclog.IotSapSyncLogMapper;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;

import javax.annotation.Resource;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.pms.enums.ErrorCodeConstant.IOT_SAP_SYNC_LOG_NOT_EXISTS;

/**
 * 操作日志记录 V2 版本 Service 实现类
 *
 * @author ruiqi
 */
@Service
@Validated
public class IotSapSyncLogServiceImpl implements IotSapSyncLogService {

    @Resource
    private IotSapSyncLogMapper iotSapSyncLogMapper;

    @Override
    public Long createIotSapSyncLog(IotSapSyncLogSaveReqVO createReqVO) {
        // 插入
        IotSapSyncLogDO iotSapSyncLog = BeanUtils.toBean(createReqVO, IotSapSyncLogDO.class);
        iotSapSyncLogMapper.insert(iotSapSyncLog);
        // 返回
        return iotSapSyncLog.getId();
    }

    @Override
    public void updateIotSapSyncLog(IotSapSyncLogSaveReqVO updateReqVO) {
        // 校验存在
        validateIotSapSyncLogExists(updateReqVO.getId());
        // 更新
        IotSapSyncLogDO updateObj = BeanUtils.toBean(updateReqVO, IotSapSyncLogDO.class);
        iotSapSyncLogMapper.updateById(updateObj);
    }

    @Override
    public void deleteIotSapSyncLog(Long id) {
        // 校验存在
        validateIotSapSyncLogExists(id);
        // 删除
        iotSapSyncLogMapper.deleteById(id);
    }

    private void validateIotSapSyncLogExists(Long id) {
        if (iotSapSyncLogMapper.selectById(id) == null) {
            throw exception(IOT_SAP_SYNC_LOG_NOT_EXISTS);
        }
    }

    @Override
    public IotSapSyncLogDO getIotSapSyncLog(Long id) {
        return iotSapSyncLogMapper.selectById(id);
    }

    @Override
    public PageResult<IotSapSyncLogDO> getIotSapSyncLogPage(IotSapSyncLogPageReqVO pageReqVO) {
        return iotSapSyncLogMapper.selectPage(pageReqVO);
    }

}